﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
' // this template is based on Atlas SMS Gateway


Sub Class_Globals
	
	Private Root 		As B4XView
	Private xui 		As XUI
	Private cs 			As CSBuilder
	Private dialog		As B4XDialog
	
	' // Declare all the Pages that the app will use
	Public pgSettings 			As B4XSettingsPage
	
	' // drawer
	Private Drawer 					As B4XDrawer
	Private HamburgerIcon 			As B4XBitmap
	Private clvMainMenu 			As CustomListView
	' // device identity - 
	Private lblManufacturer 		As B4XView
	Private lblProduct 				As B4XView
	Private lblModel 				As B4XView
	Private lblVersion 				As B4XView
	
	
End Sub

Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	
	' // This is the root page
	Root = Root1
	Root.LoadLayout("MainPage")
	
	' // here setup all other pages that we want to use
	pgSettings.Initialize
	B4XPages.AddPage("settings", pgSettings)
	

	' // Page Dialog object
	dialog.Initialize(Root)

	' // drawer for main page
	Drawer.Initialize(Me, "Drawer", Root, 90%x)
	Drawer.CenterPanel.LoadLayout("MainPage")
	Drawer.LeftPanel.LoadLayout("MainPageLeft")
	HamburgerIcon = xui.LoadBitmapResize(File.DirAssets, "ic_menu_white_24dp.png", 32dip, 32dip, True)
	
	' // setup the page
	setTitle
	build_toolbar_buttons
	build_drawer
	
	
End Sub

Sub setTitle
	
	B4XPages.SetTitle(Me,cs.Initialize.Color(xui.Color_White).Append(Application.LabelName).PopAll)
		
End Sub

Sub build_toolbar_buttons
	
	Dim xml As XmlLayoutBuilder
	Dim bd As BitmapDrawable
	Dim menus As List = B4XPages.GetManager.GetPageInfoFromRoot(Root).Parent.MenuItems
	menus.Clear

	' // lock/unlock menu
	If Drawer.GestureEnabled Then
		bd = xml.GetDrawable("ic_lock_open_white_24dp")
		' // add menu items
		Dim mi As B4AMenuItem = B4XPages.AddMenuItem(Me, "Lock")
		mi.AddToBar = True
		mi.Bitmap = bd.Bitmap
		mi.Tag = "lock"
	Else
		bd = xml.GetDrawable("ic_lock_outline_white_24dp")
		' // add menu items
		Dim mi As B4AMenuItem = B4XPages.AddMenuItem(Me, "Unlock")
		mi.AddToBar = True
		mi.Bitmap = bd.Bitmap
		mi.Tag = "lock"
	End If
	
	' // brightness
	bd = xml.GetDrawable("ic_brightness_medium_white_24dp")
	' // add menu items
	Dim mi As B4AMenuItem = B4XPages.AddMenuItem(Me, "Adjust Brightness")
	mi.AddToBar = True
	mi.Bitmap = bd.Bitmap
	mi.Tag = "brightness"
		
	' // messaging
	bd = xml.GetDrawable("ic_chat_white_24dp")
	' // add menu items
	Dim mi As B4AMenuItem = B4XPages.AddMenuItem(Me, "SMS")
	mi.AddToBar = True
	mi.Bitmap = bd.Bitmap
	mi.Tag = "sms"
		
	' // phone	
	bd = xml.GetDrawable("ic_call_white_24dp")
	' // add menu items
	Dim mi As B4AMenuItem = B4XPages.AddMenuItem(Me, "Phone Dialer")
	mi.AddToBar = True
	mi.Bitmap = bd.Bitmap
	mi.Tag = "phone"
	
	
	' // force the redraw of the toolbar buttons
	Dim ctxt As JavaObject
	ctxt.InitializeContext
	ctxt.RunMethod("invalidateOptionsMenu", Null)
	
End Sub

Private Sub B4XPage_Appear
	
	Sleep(0)
	
	' // https://developer.android.com/reference/android/app/ActionBar?hl=en
	Dim actionbar As JavaObject = B4XPages.GetManager.ActionBar
	
	
	If actionbar.IsInitialized Then
		' // This allows us to lock access the menus
		If Drawer.GestureEnabled Then
			actionbar.RunMethod("setDisplayHomeAsUpEnabled", Array(Drawer.GestureEnabled))
			Dim bd As BitmapDrawable
			bd.Initialize(HamburgerIcon)
			actionbar.RunMethod("setHomeAsUpIndicator", Array(bd))
		End If
	End If

End Sub

private Sub B4XPage_Disappear


	
	
End Sub

' // trap the hamburger clickq		
Private Sub B4XPage_CloseRequest As ResumableSub
	
	' // home button
	If Main.ActionBarHomeClicked Then
		Drawer.LeftOpen = Not(Drawer.LeftOpen)
		Return False
	End If
	' // back key
	If Drawer.LeftOpen Then
		Drawer.LeftOpen = False
		Return False
	End If
	
	Return True
End Sub

Sub B4XPage_MenuClick (Tag As String)
	
	If Tag = "lock" Then
		Drawer.GestureEnabled = Not(Drawer.GestureEnabled)
		B4XPages.GetManager.ActionBar.RunMethod("setDisplayHomeAsUpEnabled", Array(Drawer.GestureEnabled))
		
		CallSubDelayed(Me,"build_toolbar_buttons")
		
		
	End If
		
	
	If Tag = "settings" Then
		CallSubDelayed(Me,"open_settings")
	End If
	
	
End Sub


#region DRAWER

Sub build_drawer
	
	Dim p As Phone
	Dim pm As PackageManager
	
	clvMainMenu.clear

	' // app/Device Info
	Dim mView As B4XView = xui.CreatePanel("")
	mView.LoadLayout("MainPage_mnu_info")
	mView.SetLayoutAnimated(0,0,0,100%x,mView.GetView(0).Height+5dip)
	lblManufacturer.Text = p.Manufacturer
	lblProduct.Text = p.Product
	lblModel.Text = p.Model
	lblVersion.Text = pm.GetVersionName(Application.PackageName)
	clvMainMenu.Add(mView,"")
	' // sep
	Dim mView As B4XView = xui.CreatePanel("")
	mView.LoadLayout("drawer_seperator")
	mView.SetLayoutAnimated(0,0,0,100%x,mView.GetView(0).Height+5dip)
	clvMainMenu.Add(mView,"")
	
	' // actions
	Dim mView As B4XView = xui.CreatePanel("")
	mView.LoadLayout("MainPage_mnu_applications")
	mView.SetLayoutAnimated(0,0,0,100%x,mView.GetView(0).Height+5dip)
	clvMainMenu.Add(mView,"applications")
	Dim mView As B4XView = xui.CreatePanel("")
	mView.LoadLayout("MainPage_mnu_getapplist")
	mView.SetLayoutAnimated(0,0,0,100%x,mView.GetView(0).Height+5dip)
	clvMainMenu.Add(mView,"getapplist")
	Dim mView As B4XView = xui.CreatePanel("")
	mView.LoadLayout("MainPage_mnu_refresh")
	mView.SetLayoutAnimated(0,0,0,100%x,mView.GetView(0).Height+5dip)
	clvMainMenu.Add(mView,"refresh")
	Dim mView As B4XView = xui.CreatePanel("")
	mView.LoadLayout("MainPage_mnu_update")
	mView.SetLayoutAnimated(0,0,0,100%x,mView.GetView(0).Height+5dip)
	clvMainMenu.Add(mView,"update")
	Dim mView As B4XView = xui.CreatePanel("")
	mView.LoadLayout("MainPage_mnu_get")
	mView.SetLayoutAnimated(0,0,0,100%x,mView.GetView(0).Height+5dip)
	clvMainMenu.Add(mView,"get")
	Dim mView As B4XView = xui.CreatePanel("")
	mView.LoadLayout("MainPage_mnu_verify")
	mView.SetLayoutAnimated(0,0,0,100%x,mView.GetView(0).Height+5dip)
	clvMainMenu.Add(mView,"verify")
	
	' // sep
	Dim mView As B4XView = xui.CreatePanel("")
	mView.LoadLayout("drawer_seperator")
	mView.SetLayoutAnimated(0,0,0,100%x,mView.GetView(0).Height+5dip)
	clvMainMenu.Add(mView,"")
	
	' // Settings
	Dim mView As B4XView = xui.CreatePanel("")
	mView.LoadLayout("MainPage_mnu_settings")
	mView.SetLayoutAnimated(0,0,0,100%x,mView.GetView(0).Height+5dip)
	clvMainMenu.Add(mView,"settings")		
	Dim mView As B4XView = xui.CreatePanel("")
	mView.LoadLayout("MainPage_mnu_showappsettings")
	mView.SetLayoutAnimated(0,0,0,100%x,mView.GetView(0).Height+5dip)
	clvMainMenu.Add(mView,"showappsettings")
	Dim mView As B4XView = xui.CreatePanel("")
	mView.LoadLayout("MainPage_mnu_displayprofileapps")
	mView.SetLayoutAnimated(0,0,0,100%x,mView.GetView(0).Height+5dip)
	clvMainMenu.Add(mView,"displayprofileapps")
	
	
	
	' // sep
	Dim mView As B4XView = xui.CreatePanel("")
	mView.LoadLayout("drawer_seperator")
	mView.SetLayoutAnimated(0,0,0,100%x,mView.GetView(0).Height+5dip)
	clvMainMenu.Add(mView,"")
	
	
	
	' // Send Logs
	Dim mView As B4XView = xui.CreatePanel("")
	mView.LoadLayout("MainPage_mnu_sendlogs")
	mView.SetLayoutAnimated(0,0,0,100%x,mView.GetView(0).Height+5dip)
	clvMainMenu.Add(mView,"sendlogs")
	' // Remove log file
	Dim mView As B4XView = xui.CreatePanel("")
	mView.LoadLayout("MainPage_mnu_deletelogs")
	mView.SetLayoutAnimated(0,0,0,100%x,mView.GetView(0).Height+5dip)
	clvMainMenu.Add(mView,"deletelogs")
	
	Dim mView As B4XView = xui.CreatePanel("")
	mView.LoadLayout("MainPage_mnu_reboot")
	mView.SetLayoutAnimated(0,0,0,100%x,mView.GetView(0).Height+5dip)
	clvMainMenu.Add(mView,"reboot")
	
	
	' // sep
	Dim mView As B4XView = xui.CreatePanel("")
	mView.LoadLayout("drawer_seperator")
	mView.SetLayoutAnimated(0,0,0,100%x,mView.GetView(0).Height+5dip)
	clvMainMenu.Add(mView,"")
	
	' // Exit App
	Dim mView As B4XView = xui.CreatePanel("")
	mView.LoadLayout("MainPage_mnu_exit")
	mView.SetLayoutAnimated(0,0,0,100%x,mView.GetView(0).Height+5dip)
	clvMainMenu.Add(mView,"exitapp")
	
End Sub

Private Sub clvMainMenu_ItemClick (Index As Int, Value As Object)
	
	
	' // close the drawer, keeps the draft out .....
	If Drawer.LeftOpen Then
		Drawer.LeftOpen = False
	End If
	
	If Value = "settings" Then
		open_settings
	End If

	
	If Value = "clean_outbox" Then
	End If

	If Value = "updateapp" Then
		'StartService(DownloadService)
	End If

	If Value = "exitapp" Then
		ExitApplication
	End If
	
End Sub

#End Region

Sub open_settings
	
	dialog.Title = "Settings"
	dialog.TitleBarColor = 0xFF8B0000
	'dialog.BackgroundColor = 0xFFFFFFFF
	dialog.PutAtTop = True
	
	
	Dim input 	As B4XInputTemplate
	input.Initialize
	input.lblTitle.Text = "Enter PIN Code"
	input.ConfigureForNumbers(False, False)
	input.RegexPattern = ".+"
	input.TextField1.TextColor = xui.Color_White
	input.TextField1.SetColorAndBorder(xui.Color_Black,2dip,xui.Color_white,0dip)
	
	Wait For (dialog.ShowTemplate(input, "OK", "", "CANCEL")) Complete (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		
		' // pincode check method
		If Main.APPSET.passcode = input.Text Then
			B4XPages.ShowPage("settings")
		Else
			ToastMessageShow("PIN Code incorrect, access denied",True)
		End If
		
	End If
	
	
End Sub

#end region



