﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.8
@EndOfDesignText@
Sub Class_Globals
	
	Private Root 			As B4XView 'ignore
	Private xui 			As XUI 'ignore
	Private cs 				As CSBuilder
	Private homeIcon	 	As B4XBitmap
	
	Private svWorkspace 		As ScrollView
	Private pnlSettingsStandard	As Panel
		
	
	' // security
	Private txtPassCodeNew 			As EditText
	Private txtPassCodeNewCheck 	As EditText
	Private btnPassCodeUpdate 		As Button
	
	' //  qr code settings
	Private QRcr 					As QRCodeReaderV102
	Private lblQRClose 				As Label
	Private QRvisible 				As Boolean
	Private QRrequested				As Boolean
	Private pnlQRsettings			As Panel
	
	
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	
	Root = Root1
	'load the layout to Root
	Root.LoadLayout("settings_workspace")
	
	homeIcon = xui.LoadBitmapResize(File.DirAssets, "ic_arrow_back_white_24dp.png", 32dip, 32dip, True)
	setTitle
	build_toolbar_buttons
	
	' // add the settings layout to the scroll view
	svWorkspace.Panel.LoadLayout("settings")
	' // set the internal height of the scrollview to enable scrolling on small screens
	If pnlSettingsStandard.Height > 90%y Then
		svWorkspace.Panel.Height = pnlSettingsStandard.Height
	Else
		svWorkspace.Panel.Height = 100%Y
	End If
	
	draw_settings
	
End Sub

Private Sub B4XPage_Appear
	
	Sleep(0)
	B4XPages.GetManager.ActionBar.RunMethod("setDisplayHomeAsUpEnabled", Array(True))
	Dim bd As BitmapDrawable
	bd.Initialize(homeIcon)
	B4XPages.GetManager.ActionBar.RunMethod("setHomeAsUpIndicator", Array(bd))
	
	
End Sub

private Sub B4XPage_Disappear
	
	If QRvisible Then
		qr_settings_close
	End If
	
End Sub


'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.


Sub build_toolbar_buttons
	
	Dim icon As B4XBitmap
	Dim menus As List = B4XPages.GetManager.GetPageInfoFromRoot(Root).Parent.MenuItems
	menus.Clear
	
	' // send log file
	icon = xui.LoadBitmap(File.DirAssets, "qrcode-scan.png")
	' // add menu items
	Dim mi As B4AMenuItem = B4XPages.AddMenuItem(Me, "QR Settings")
	mi.AddToBar = True
	mi.Bitmap = icon
	mi.Tag = "qr"
	
	' // force the redraw of the toolbar buttons
	Dim ctxt As JavaObject
	ctxt.InitializeContext
	ctxt.RunMethod("invalidateOptionsMenu", Null)
	
End Sub


Sub setTitle
	
	B4XPages.SetTitle(Me,cs.Initialize.Color(xui.Color_White).Append("Settings").PopAll)
	Dim actionbar As JavaObject = B4XPages.GetManager.ActionBar
	If actionbar.IsInitialized Then
		' // this is the sub title, you can set it anything you want that is relevent to the page being showm, or nothing at all.
		actionbar.RunMethod("setSubtitle", Array(""))
	End If
		
End Sub

Sub B4XPage_MenuClick (Tag As String)
	
	If Tag = "qr" Then
		If Not(QRvisible) Then
			qr_settings_open
		Else
			qr_settings_close
		End If
	End If
	
End Sub


Sub draw_settings
	
	
	Main.APPSET.draw_busy = True
	
	' // update the on screen 
	
	Main.APPSET.draw_busy = False

End Sub



#region SECURITY

Sub txtPassCodeNew_TextChanged (Old As String, New As String)
	
	If New.Length > 4 Then
		txtPassCodeNew.Text = Old
		txtPassCodeNew.SelectionStart = txtPassCodeNew.Text.Length
	End If
	
	
End Sub
Sub txtPassCodeNewCheck_TextChanged (Old As String, New As String)
	
	If New.Length > 4 Then
		txtPassCodeNewCheck.Text = Old
		txtPassCodeNewCheck.SelectionStart = txtPassCodeNewCheck.Text.Length
	End If
	
End Sub
Sub btnPassCodeUpdate_Click
	
	If (txtPassCodeNewCheck.Text="") And (txtPassCodeNew.Text="") Then
		Return
	End If
	
	If txtPassCodeNewCheck.Text <> txtPassCodeNew.Text Then
		ToastMessageShow("Passcode's do not match",True)
		txtPassCodeNewCheck.Text = ""
		txtPassCodeNew.Text = ""
		Return
	End If
	Main.APPSET.passcode = txtPassCodeNew.text
	mod_settings.put_passcode
	
End Sub


#End Region

#region QRCODE


Sub qr_settings_open
	
	Try
		Dim rp As RuntimePermissions
		rp.CheckAndRequest(rp.PERMISSION_CAMERA)
		'QRcr.Initialize("QRcr")
		
		Log(QRcr.BackFacingCamera)    'see the popup help when entering this method - check if there is a back facing camera and return the ID of the camera
		Log(QRcr.FrontFacingCamera)   'see the popup help when entering this method - check if there is a front facing camera and retutn the ID of the camera
	
		Log(QRcr.CAMERA_BACK)         'see the popup help when entering this method
		Log(QRcr.CAMERA_FRONT)	       'see the popup help when entering this method
	
	 
		QRrequested =False
		pnlQRsettings.Visible = True
		QRcr.Visible = True
		QRcr.CameraId = QRcr.CAMERA_BACK
		Sleep(0)
		QRcr.startScan
		Sleep(0)
		QRcr.ScanNow = True
	Catch
		mod_functions.writelog("main::qr_settings_open, error - " & LastException.message)
	End Try
	
	QRvisible = pnlQRsettings.Visible
	
End Sub

Sub lblQRClose_Click
	
	qr_settings_close
	
End Sub

Sub qr_settings_close
	
	Try
		QRcr.ScanNow = False
		QRcr.stopScan
		Sleep(500)
		QRcr.closeDriver
		Sleep(500)
		QRcr.Visible = False
		pnlQRsettings.Visible = False
	Catch
		mod_functions.writelog("main::qr_settings_close, error - " & LastException.message)
	End Try
	QRvisible = pnlQRsettings.Visible
	
End Sub

Sub QRcr_result_found(retval As String, img As Object)
	
	Dim nativeMe As JavaObject
	
	Dim cypher As B4XCipher
	Dim bc As ByteConverter
	Dim su As StringUtils
	
	' // do a beep so the user know we got the scan
	nativeMe.InitializeContext
	nativeMe.RunMethod("playTone", Null)
	qr_settings_close
	
	Dim encFail As Int
		
	' // this may be encrypted !
	If Not(retval.Contains(Application.PackageName)) Then
		Try
			Dim encData() As Byte = cypher.Decrypt(su.DecodeBase64(retval),Application.PackageName)
			Dim decData As String = bc.StringFromBytes(encData,"UTF8")
			Dim d() As String = Regex.Split(",",decData)
		Catch
			encFail = encFail + 1
		End Try
		
		' // failed encryption on both package names
		If encFail = 1 Then
			ToastMessageShow($"*QR Code does not belong to this application ${Application.PackageName}"$,True)
			Return
		End If
		
	Else
		Dim d() As String = Regex.Split(",",retval)
	End If
	
	Try
		Log($"${Application.PackageName} ${d(0)}"$)
		' // we have seven values
		If d.Length >= 0 Then
			' // check this data is for this app
			If (d(0) <> Application.PackageName)  Then
				ToastMessageShow(d(0) & " does not belong to this application, " & Application.PackageName,True)
				Return
			End If
		End If
						
		' // default pass code
		If d.Length >= 18 Then
			Main.APPSET.passcode = d(17)
			mod_settings.put_passcode	
		End If
		
		
		mod_functions.writelog($"settings::QRcr_result_found::QR settings applied to ${Application.PackageName}"$)
		ToastMessageShow($"QR settings applied to ${Application.PackageName}"$,True)
	Catch
		ToastMessageShow($"** QR Code does not belong to this application ${Application.PackageName}"$,True)
		mod_functions.writelog($"QR - error - ${LastException.Message}"$)
	End Try
End Sub



#End Region